# Extended NPC Spawn Attrition


## How to Use

**In Attrition gamemode, use the playlistvar** `aitdm_extended_spawns 1` **to enable extended NPC spawn contents**

**Please add** 

- `sv_max_props_multiplayer 500000` 
- `sv_max_prop_data_dwords_multiplayer 800000` 

**to startup args(add an extra **`+`** as prefix) or typing them in console before starting, otherwise the game might crash**


## Note

Due to weapon file modifications, this mod might be incompatible with weapon model modifications, highly recommand run on dedicated servers!

If you're not on dedicated servers, please enable `sv_cheats` and do `weapon_reparse` in console before starting the gamemode, disable `sv_cheats` after `weapon_reparse` is done


## Introduction

Similar to [GruntMode](https://northstar.thunderstore.io/package/VoyageDB_Modding_Home/Grunt_Mode) but players are pilots

Including fixes in [NessieTempFix](https://northstar.thunderstore.io/package/VoyageDB_Modding_Home/Nessie_Temp_Fix)( except gamemode fixes ), Needs testing!

Add Testing Classic Rodeo fix. Use the playlistvar `classic_rodeo 1` to enable fake Titanfall 1 style rodeo. Rodeo damage can be modified through playlistvar `classic_rodeo_damage_scale`

Add Classic Executions. Use the playlistvar `classic_execution 1` to enable fake Titanfall 1 style execution( overwrites first person executions )

**Score Events:**

Start with Specialist grunts spawning

- 80: Spectres spawning

- 150: Stalkers and Prowlers spawning

- 230: Reapers and Gunships spawning

- 330: Titans and NPC pilots spawning


## NPC Spawn Settings PlaylistVar

**PlaylistVar are variables that can be used in `setplaylistvaroverrides` command**

**They're also accessible in Private Match Settings menu( with localized display name )**

### Category: Attrition Extended(Overrides Attrition)

| **Variable** | **Display Name in Private Match** | **Description** | **Default value** | **Accepted Value** |
|:------------:|:---------------------------------:|:---------------:|:-----------------:|:------------------:|
| `aitdm_extended_spawns` | Enable Attrition Extended | If set to 1, overrides basic Attrition with extended npc spawns | `0` | 0-1 |
| `aitdm_extended_coop` | Attrition Extended COOP Variant | Requires `aitdm_extended_spawns 1`. If set to 1, enable COOP variant of Attrition Extended: All players at the same team against enemy NPCs | `0` | 0-1 |
| `aitdm_coop_team_boss_titans` | COOP: Boss Titan based On Player Team | Requires `aitdm_extended_coop 1`. If set to 1, enemy boss titan will spawn in specific team variant( eg. Ash, Blisk, Slone if player in TEAM_MILITIA; Jack, Sarah, Vanguard-Class if player in TEAM_IMC ) | `0` | 0-1 |
| `aitdm_coop_friendly_npc_percent` | COOP: Friendly NPC Percentage | Requires `aitdm_extended_coop 1`. The percentage of how many friendly NPCs will spawn( eg. 0.5 means there'll only be half of normal npc count on your team, 0.0 means there won't be any npc on your team ) | `0.7` | Any Positive Float value |
| `aitdm_coop_enemy_npc_min_percent` | COOP: Enemy NPC Percentage at Single Player | Requires `aitdm_extended_coop 1`. The percentage of how many enemy NPCs will spawn when you're the only player in server | `1.0` | Any Positive Float value |
| `aitdm_coop_enemy_npc_increment_per_player` | COOP: Enemy NPC Percentage Increment Per Player | Requires `aitdm_extended_coop 1`. The percentage added to `aitdm_coop_enemy_npc_min_percent` for each player in the game. Max percentage is `aitdm_coop_enemy_npc_max_percent` | `0.5` | Any Positive Float value |
| `aitdm_coop_enemy_npc_max_percent` | COOP: Enemy NPC Percentage at Max Increment | Requires `aitdm_extended_coop 1`. The max increment of npc percentage based on player count | `2.5` | Any Positive Float value |
| `aitdm_coop_pilot_score_multiplier` | COOP: Enemy Score Multiplier from Killing Pilots | Requires `aitdm_extended_coop 1`. For adding some challenge. When enemy NPC kills a player controlled pilot character, the score they get will be multiplied by this value( eg. 5.0 means enemy npcs will gain 25(5*5) score on killing your pilot, makes sometimes you can lose the game if not careful enough ) | `2.0` | Any Positive Float value |
| `aitdm_coop_titan_score_multiplier` | COOP: Enemy Score Multiplier from Killing Titans | Requires `aitdm_extended_coop 1`. For adding some challenge. When enemy NPC kills a player owned titan, the score they get will be multiplied by this value( eg. 8.0 means enemy npcs will gain 80(10*8) score on killing your pilot, makes sometimes you can lose the game if not careful enough ) | `3.0` | Any Positive Float value |

### Category: Modded Attrition Gamemode Spawn Settings

| **Variable** | **Display Name in Private Match** | **Description** | **Default value** | **Accepted Value** |
|:------------:|:---------------------------------:|:---------------:|:-----------------:|:------------------:|
| `modaitdm_squad_count` | Squads Per Team | How many infantry squads a team can have | `5` | Any Positive Int value |
| `modaitdm_squad_count_high_level` | Squads Per Team at Highter Score Level | When reaper starts deploying, `modaitdm_squad_count` will be replaced by this value | `3` | Any Positive Int value |
| `modaitdm_prowler_count` | Prowlers Per Team | How many prowlers a team can have | `4` | Any Positive Int value |
| `modaitdm_reaper_count` | Reapers Per Team | How many reapers a team can have | `2` | Any Positive Int value |
| `modaitdm_gunship_count` | Gunships Per Team | How many gunships a team can have | `2` | Any Positive Int value |
| `modaitdm_pilot_count` | NPC Pilots Per Team | How many npc pilots and their titans a team can have | `3` | Any Positive Int value |
| `modaitdm_spectre_spawn_score` | Spectre Score Level | How many score required to make enemy team start deploying spectres | `80` | Any Positive Int value |
| `modaitdm_stalker_spawn_score` | Stalker Score Level | How many score required to make enemy team start deploying stalkers and prowlers | `150` | Any Positive Int value |
| `modaitdm_reaper_spawn_score` | Reaper Score Level | How many score required to make enemy team start deploying reapers and gunships | `230` | Any Positive Int value |
| `modaitdm_titan_spawn_score` | Titan Score Level | How many score required to make enemy team start deploying npc pilots and their titans | `330` | Any Positive Int value |
| `modaitdm_boss_replace_chance` | Boss Titan Replace Chance | Chance of replacing a normal npc pilot titan spawn with boss titan spawn | `0.33` | Any Positive Float value |


## Change Logs

**v1.8.7**

- Add playlistvar `modaitdm_boss_replace_chance` to allow modify boss titan spawn

- Reduce the default chance boss titans can spawn, because they've got stronger executions

- Add more stable timer for reaper nuke sequence


**v1.8.6**

- Fix laser core damage can instant make reapers start nuke sequence

- Make all boss titans bring themselves out of doomed state on receiving battery


**v1.8.5**

- Make reaper's health bar and highlight visible during nuke sequence, so it's easier to recognize their team

- Redirect score to any valid attacker if a titan ejects and their last attacker already being cleaned up, try to make score blanking less likely to happen


**v1.8.4**

- Fix a crash related with classic execution

- Fix classic execution visual effect


**v1.8.3**

- Stalkers now always detonate themselves no matter what kills them, unless they're killed by headshot damage

- Fix stalkers don't detonate themselves when getting stepped by titans at low health

- Fix stalkers won't detonate themselves after being killed by plasma railgun or scorch's thermite

- Make owner can kill their hacked spectres... This might be vanilla behavior?


**v1.8.2**

- Fix stalker can deal doubled explosion damage on getting stepped by titans

- Add melee capability after a stalker's right arm is dismembered


**v1.8.1**

- Rework stalkers:

    - They won't get overloaded in any critical hit, that only happens when their health is very low

    - Their body parts won't be dismembered in any shot, have to receive enough damage before becoming crawling

    - They'll always try to detonate themselves after being killed by titans

- Nerf npc burst core damage against titans

- Fix crash happen when a spectre or stalker getting headshot at by other npcs

- Make npc titan unable to be executed when playing scripted animation, to prevent bad execution sequence


**v1.8.0**

- Add much wider spawn point search for titans and prevent them spawning together at one point

- Try to fix crash happens when cleaning up idle prowlers

- Make all boss titans reward themselves a battery after execution

- Add battery reward support for classic executions( eg. monarch with energy thief )

- Make npcs don't target eject flight npc pilots often

- Specialist grunt's health now scales up based on current team's spawn level


**v1.7.16**

- Fix player archon crashes server when performing execution

- Fix npc titan become unarmed after using ion prime execution


**v1.7.15**

- Fix brute4 gets infinite cluster ammo for their quad rocket after execution

- Fix titans have longer weapon deploy time after execution


**v1.7.14**

- Add alternative core ability for npc Legion and Monarch


**v1.7.13**

- Fix npc titan nuke eject dealing extremely high damage


**v1.7.12**

- Rename playlistvar `classic_execution_enabled` to `classic_execution`

- Remove classic embark bind together with classic executions

- Fix npc pilot become invincible after failed to embark

- Add `random_titan_execution`. Titans will pick random execution used by current chassis

- Make npc gunship less likely to be targeted by ground units, reduce max health

- Make npc titans more aggresive on searching for enemy titans

- Make Playlistvar settings able to impact npc spawn order( no longer forced to use spectre->stalker->reaper->titan order )

- Make classic rodeo more stable


**v1.7.11**

- Update Readme


**v1.7.10**

- Fix npc pilot's melee range

- Add more weapons for grunts and spectres

- Remove modified double barrel shotgun file

- Fix classic execution ragdoll and visibility stuffs


**v1.7.9**

- Revert "v1.7.6: Fix player unable to call in titan after failed to Respawn As Titan"... I can't figure out how to rework earn meter after this. Temporary remove the fix, at least the gamemode can be running properly

- Add Northstar v1.20.0 compatibility


**v1.7.8**

- Fix titan core meter always display as 100% when respawn as titan while watching replay


**v1.7.7**

- Fix npc pilot can flee from titan

- Fix atlas classic execution's weird sequence duration, fix bad emarking animation

- Make specialist grunt throw grenades more often, disable their ability to switch to pistol


**v1.7.6**

- Fix npc pilot combat behavior

- Fix player unable to call in titan after failed to Respawn As Titan

- Add sound event for titan classic executions

- Fix Archon's modified audio compatibility


**v1.7.5**

- Fix player always gain an extra electric smoke when earning from no smoke in inventory


**v1.7.4**

- Add Classic Executions

- Fix first person executions crash if player is target

- Fix npc titan ejecting animation


**v1.7.3**

- Fix a crash that happens when player "Out of sync with server"


**v1.7.2**

- Fix a runtime error caused by npc pilot weapon attachment


**v1.7.1**

- Revert "v1.6.10: Fix spectres can be hacked multiple time"... it is vanilla behavior! Kinda funny one

- Fix npc pilot's incorrect weapon damage

- Add more weapons for npc pilot

- Fix npc Vanguard-Class titan's rodeo sound

- Add Testing Classic Rodeo fix. Try to fix crash and add some gameplay tweak

- Add back first person executions. It's added by Northstar but was missing in this mod before this version


**v1.7.0**

- Update Readme

- Add PlaylistVar settings... maybe too much complicated but idk how to make them better

- Add localization for Private Match Settings if installed on client-side

- Merge gunship spawn into reaper score event


**v1.6.12**

- Make npc Vanguard-Class titan's health bar visible

- Fix npcs targeting embarking npc pilots

- Fix npc friendly highlights


**v1.6.11**

- Add better npc pilot ejecting behavior, reduce the chance they get stuck in rooftop or somewhere


**v1.6.10**

- Fix spectres can be hacked multiple time


**v1.6.9**

- Make reaper unable to melee rodeo player when they're targeting the titan

- Add attachments for npc weapons


**v1.6.8**

- Update Readme

- Add NPC Gunship spawn

- Add compatibility with Northstar v1.19.9


**v1.6.7**

- Fix incorrect release package that causes game to crash or having chinese localizations


**v1.6.6**

- Update Readme


**v1.6.5**

- Fix Brute4 compatibility

- Make infantry with AT weapon don't running around when titan getting close

- Remove npc specialist grunt spawn with stalkers

- Balance npc specialist grunt weapons( buff elite-guard grunts and nerf sniper grunts )

- Increase stalker health

- Balance stalker weapons( buff epg, softball and nerf smr )

- Remove prowler squad spawns and replace with normal prowlers

- Increase prowler health

- Increase the damage prowlers dealt to titans and reapers

- Fix npc not switching to AT weapon on player embarking

- Add dangerous area for npc titan( excluded player owned titans ) and reaper's drop spot

- Make npcs don't target other npc titans( excluded player owned titans ) in bubble shield

- Make npc titan unable to melee rodeo player when they're targeting the titan


**v1.6.4**

- Fix incorrect kill replay callsign display when killed by a npc

- Fix player gain an extra electric smoke when respawn as titan with Overcore

- Fix a crash that may happen during intro spawn


**v1.6.3**

- Add compatibility with following update: [PR#701](https://github.com/R2Northstar/NorthstarMods/pull/701)


**v1.6.2**

- Fix a client script error related with npc arcball weapons


**v1.6.1**

- Fix titan loadout selection crash when enabled TitanFrameWork


**v1.6.0**

- Add compatibility with [TitanFrameWork](https://northstar.thunderstore.io/package/The_Peepeepoopoo_man/Titanframework/)

- Add NPC Archon if you have installed the mod [MoblinArchon](https://northstar.thunderstore.io/package/GalacticMoblin/MoblinArchon/), and NPC Brute4 spawns if installed [DinorushBrute4](https://northstar.thunderstore.io/package/Dinorush/DinorushBrute4/)


**v1.5.3**

- Use spawn waves for npc spawn to make it more stable

- Use custom execution chooser for npcs

- Add compatibility with following update: [PR#554](https://github.com/R2Northstar/NorthstarMods/pull/554)


**v1.5.2**

- Bug fixes about compilation


**v1.5.1**

- Add npc titan rodeo countermeasure( electric smoke )


**v1.5.0**

- Add compatibility with Northstar v1.18.0